import 'dart:convert';

extension ListExtraUtils on List {
  String get Json {
    return jsonEncode(this);
  }

  String get JsonPretty {
    return JsonEncoder.withIndent('\t').convert(this);
  }

  List AddIfNotExist(dynamic element) {
    this.forEach((other) { 
      if(other == element)
        return this;
    });

    this.add(element);
    return this;
  }

  List AddAllIfNotExist(List newList) {
    newList?.forEach((element) { 
      this.AddIfNotExist(element);
    });

    return this;
  }

  bool ForEach(bool Function(dynamic element) step) {
    for(var i = 0; i<this.length; i++) {
      if(step(this[i]) == false)
        return false;
    }

    return true;
  }

  bool ForEachCounter(bool Function(dynamic element, int index) step) {
    for(var i = 0; i<this.length; i++) {
      if(step(this[i],i) == false)
        return false;
    }

    return true;
  }

}
